unit HTTPXMLPostUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  ApplicationWorkUnit,
  CalcWorkUnit,
  IdTCPClient, IdHTTP, IdAntiFreezeBase, IdAntiFreeze, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    IdHTTP1: TIdHTTP;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    StatusBar1: TStatusBar;
    IdAntiFreeze1: TIdAntiFreeze;
    Memo3: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    TrackBar1: TTrackBar;
    Button4: TButton;
    Timer1: TTimer;
    Memo4: TMemo;
    Edit2: TEdit;
    HostSub: TCheckBox;
    LabelPostTo: TLabel;
    LabelWhite: TLabel;
    Panel3: TPanel;
    LabelSel: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo2Enter(Sender: TObject);
    procedure Memo2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HostSubClick(Sender: TObject);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure LoadFiles(pFileNumber: Integer);
    procedure SaveFiles(pFileNumber: Integer);
    procedure GetTextCopy;
    function SubstHOSTString(pURL, pRepHost: String): String;
    procedure UpdateCaptions;
    procedure TrimWhite;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  GlobReqFileName: String;
  GlobResFileName: String;
  GlobUrlFileName: String;
  GlobOthFileName: String;

  GlobModified   : Boolean;

  GlobUrlSave    : String;
  GlobReqSave    : String; //TStringList;

const
/////////////////////////////////////
{$I ConstStandardInclude.pas}
/////////////////////////////////////

implementation
{$R *.dfm}
{$WARN UNIT_PLATFORM OFF}
{$R manifest.res}  // For use with Pretty XP graphics


procedure TForm1.FormCreate(Sender: TObject);
begin
     // DoubleBuffer and change general system defaults, look and feel
     AdjustApplicationToStandards(Self);
     // Load form locations and grid column settings
     WinLocationsCreate(Application.ExeName, Self);

     GlobModified   := False;
     LoadFiles(TrackBar1.Position);

     GlobOthFileName := ChangeFileExt(Application.ExeName, '_url.txt');
     Memo4.Clear;
     if FileExists(GlobOthFileName) then
     begin
          Memo4.Lines.LoadFromFile (GlobOthFileName);
     end
     else
     begin
          Memo4.Lines.Add('http://127.0.0.1/');
     end;
     Edit2.Text := Memo4.lines[0];
     //GlobReqSave    := TStringList.Create;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
     //GlobReqSave.Free;
     Memo4.Clear;
     Memo4.Lines.Add(Edit2.Text);
     Memo4.Lines.SaveToFile (GlobOthFileName);
end;



procedure TForm1.LoadFiles(pFileNumber: Integer);
var
   mNum : String;
begin
     mNum := RightCopy('00'+IntToStr(pFileNumber),2);

     GlobUrlFileName := 'HTTPXML_'+mNum+'_URL.txt';
     GlobReqFileName := 'HTTPXML_'+mNum+'_Request.xml';
     GlobResFileName := 'HTTPXML_'+mNum+'_Response.xml';

     Memo3.Text := 'http://127.0.0.1';
     try
        // If the URL exists, load the others too
        if fileexists(GlobUrlFileName) then
        begin
             // Set the colours
             Edit1.Color := clWindow;
             Memo1.Color := clWindow;
             Memo2.Color := clWindow;

             Memo3.Lines.LoadFromFile (GlobUrlFileName);

             try
                Memo2.Clear;
                if fileexists(GlobReqFileName) then
                begin
                     Memo2.Lines.LoadFromFile (GlobReqFileName);
                     StatusBar1.Panels[1].Text := 'Loaded: '+GlobReqFileName;
                end;
             except
             end;

             try
                Memo1.Clear;
                if fileexists(GlobResFileName) then
                begin
                     Memo1.Lines.LoadFromFile (GlobResFileName);
                     TrimWhite;
                end;
             except
             end;
        end
        else
        begin
             // Not found
             // Set the colours
             Edit1.Color := cColInactiveGray;
             Memo1.Color := cColInactiveGray;
             Memo2.Color := cColInactiveGray;

             Edit1.Clear;
             Memo1.Clear;
             Memo2.Clear;
        end;
     except
     end;

     Edit1.Text := Memo3.Lines[0];
     UpdateCaptions;
     GlobModified   := False;
end; // LoadFiles


// SliderBar
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
     LabelWhite.Caption := '';
     TrackBar1.OnChange := Nil;
     if (GlobModified = True) then
     begin
          if AppMessageDlg('Abandon modifications?',
            mtConfirmation, [mbYes, mbNo, mbCancel], 0, Panel1.Color ) = mrYes then
          begin
               GlobModified := False;
               LoadFiles(TrackBar1.Position);
          end;
     end
     else
     begin
          LoadFiles(TrackBar1.Position);
     end;
     LabelSel.Caption := IntToStr(TrackBar1.Position);
     GetTextCopy;
     Memo2.SetFocus;
     TrackBar1.OnChange := TrackBar1Change;
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
     SaveFiles(TrackBar1.Position);
end;


procedure TForm1.SaveFiles(pFileNumber: Integer);
var
   mNum : String;
begin
     mNum := RightCopy('00'+IntToStr(pFileNumber),2);

     GlobUrlFileName := 'HTTPXML_'+mNum+'_URL.txt';
     GlobReqFileName := 'HTTPXML_'+mNum+'_Request.xml';
     GlobResFileName := 'HTTPXML_'+mNum+'_Response.xml';

     Memo3.Clear;
     Memo3.Lines.Add(Edit1.Text);
     Memo3.Lines.SaveToFile(GlobUrlFileName);
     Memo2.Lines.SaveToFile(GlobReqFileName);
     Memo1.Lines.SaveToFile(GlobResFileName);
     StatusBar1.Panels[1].Text := 'Saved: '+GlobReqFileName;

     GlobModified   := False;
end;



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     // Save form locations and grid column settings
     WinLocationsClose(Application.ExeName, Self);

end;




procedure TForm1.Button1Click(Sender: TObject);
var
   httpCon  : TIdHTTP;
   //FormData: TidMultiPartFormDataStream;
   scriptUrl: String;
   body     : String;
   RequestStream:  TMemoryStream;
   ResponseStream: TMemoryStream;
begin
     SaveFiles(TrackBar1.Position);
     // Show that we are expecting some response
     LabelWhite.Caption := '';
     Memo1.Clear;

     Application.ProcessMessages;

     ResponseStream := TMemoryStream.Create;
     RequestStream  := TMemoryStream.Create;
     //FormData       := TIdMultiPartFormDataStream.Create;
     httpCon        := TIdHTTP.Create(nil);

     try
        body := '';  // Initialise the return value from the GET Command.

        httpCon.Request.BasicAuthentication := true;  // Set Basic Authentification

        httpCon.HandleRedirects := true;   // Set it to true so it can redirect if the server requires to.

        //httpCon.Request.Username := userName;
        //httpCon.Request.Password := password;
        httpCon.ReadTimeout := 0;   //infinite timeout

        scriptUrl := LabelPostTo.Caption; //Edit1.Text; // 'http://127.0.0.1/medtek/syscommand.php';

        RequestStream.LoadFromFile(GlobReqFileName);

        httpCon.Post(scriptUrl, RequestStream, ResponseStream);

        // Save and Load
        ResponseStream.Position := 0;
        ResponseStream.SaveToFile(GlobResFileName);
        Memo1.Lines.LoadFromFile (GlobResFileName);
        TrimWhite;
     finally
        ResponseStream.Free;
        RequestStream.Free;
        //FormData.Free;
        httpCon.Free;
     end;
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
  if AppMessageDlg('Are you sure you want to clear request section?',
    mtConfirmation, [mbYes, mbNo], 0, Panel1.Color ) = mrYes then
  begin
       Memo2.Clear;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     Memo1.Clear;
     LabelWhite.Caption := '';
end;


// Trim white
procedure TForm1.TrimWhite;
var
   mLoop    : Integer;
   mStrings : TStringList;
begin
     LabelWhite.Caption := '';
     Memo1.Perform( WM_SETREDRAW, 0, 0 );
     mStrings := TStringList.Create;
     try
        mStrings.AddStrings(Memo1.Lines);

        mLoop := 0;
        while mLoop <= mStrings.Count - 1 do
        begin
             if Trim(mStrings[mLoop]) = '' then
             begin
                  mStrings.Delete(mLoop);
                  LabelWhite.Caption := 'White space removed';
             end
             else
             begin
                  inc(mLoop);
             end;
        end;

        Memo1.Clear;
        Memo1.Lines.AddStrings(mStrings);
     finally
        mStrings.Free;
        Memo1.Perform( WM_SETREDRAW, 1, 0 );
     end;
end;


procedure TForm1.GetTextCopy;
begin
     GlobUrlSave := Edit1.Text;
     GlobReqSave := Memo2.Text;
end;


procedure TForm1.Edit1Enter(Sender: TObject);
begin
     GetTextCopy;
end;

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if (GlobUrlSave <> Edit1.Text) then
     begin
          GlobModified   := True;
     end;
     UpdateCaptions;
end;

procedure TForm1.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     UpdateCaptions;
end;


procedure TForm1.UpdateCaptions;
begin
     if HostSub.Checked then
     begin
          LabelPostTo.Caption := SubstHOSTString(Edit1.Text, Edit2.Text);
     end
     else
     begin
          LabelPostTo.Caption := Edit1.Text;
     end;
end;


procedure TForm1.HostSubClick(Sender: TObject);
begin
     UpdateCaptions;
     StatusBar1.Panels[1].Text := 'URL: '+LabelPostTo.Caption;
end;

procedure TForm1.Memo2Enter(Sender: TObject);
begin
     GetTextCopy;
end;

procedure TForm1.Memo2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if (GlobReqSave <> Memo2.Text) then
     begin
          GlobModified   := True;
     end;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
     StatusBar1.Panels[0].Text := iff(GlobModified, 'Modified', '');
end;


function TForm1.SubstHOSTString(pURL, pRepHost: String): String;
var
   mCopy  : String;
   mPos   : Integer;
begin
     // Make sure the user is not a twit
     if Copy(pURL,1,7) = 'http://' then
     begin
          // Dont include the http bit
          mCopy  := Copy(pURL,8,999);
          mPos   := Pos('/', mCopy);
          result := pRepHost + copy(mCopy, mPos+1, 999);
     end
     else
     begin
          // Nothing can happen
          result := pURL;
     end;
end;



end.
